﻿Imports Microsoft.StylusInput

Public Class App
    'Shared _instance As App = Nothing
    'Private Shared obj As Object

    'Shared ReadOnly Property Instance() As App
    '    Get
    '        obj = New Object
    '        SyncLock obj
    '            If IsNothing(App._instance) Then
    '                App._instance = New App
    '            End If
    '        End SyncLock

    '        Return App._instance
    '    End Get
    'End Property

    ReadOnly Property CanvasPanel As CanvasPanel
        Get
            Return Me._canvasPanel
        End Get
    End Property

    ReadOnly Property ToolPanel As ToolPanel
        Get
            Return Me._toolPanel
        End Get
    End Property

    Private Sub App_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        Label3.Text = "x" & CanvasPanel.ViewScale.ToString()

        ' Initialize Stylus
        Dim stylus As New RealTimeStylus(Me.CanvasPanel._pictureBox)
        Debug.Assert(Not IsNothing(stylus))
        With stylus
            .WindowInputRectangle = New Rectangle(0, 0, 0, 0)  '組み込み先コントロール全体を使用
            .AsyncPluginCollection.Add(New AsyncPlugin)
            'TODO:SyncPluginで画面描画が行われないことについて
            '.SyncPluginCollection.Add(New _SyncPlugin)
            .AllTouchEnabled = False
            .FlicksEnabled = False
            .MultiTouchEnabled = False
            .Enabled = True
        End With

        LoadAllPlugin()

    End Sub

    Public Sub LoadAllPlugin()

        Dim files = System.IO.Directory.GetFiles(System.IO.Path.Combine(System.Windows.Forms.Application.StartupPath, "Plugin"), "*.dll", IO.SearchOption.AllDirectories).GetEnumerator()
        Do While files.MoveNext()
            Debug.Print("Found DLL:" & DirectCast(files.Current, String))
            Dim asm = Reflection.Assembly.LoadFrom(DirectCast(files.Current, String))
            Dim types = asm.GetTypes().GetEnumerator()
            Do While types.MoveNext()
                Dim t = DirectCast(types.Current(), Type)
                Debug.Print("Found Class:" & t.FullName)
                Dim commands = New List(Of Plugin.Brushes.BrushCommand)
                Dim tag = New List(Of Object)
                tag.Add(commands)
                'Debug.Assert(tag(Button_Commands) Is commands)
                If t.IsSubclassOf(Type.GetType("WindowsApplication1.Plugin.BrushCommand,WindowsApplication1.Plugin", True, True)) Then
                    Debug.Print("Loaded (Command):" & t.FullName)
                    Dim cmd = asm.CreateInstance(t.FullName)
                    Dim b = New Button()
                    With b
                        .Tag = tag
                        .Text = t.Name
                        .AutoSizeMode = AutoSizeMode.GrowAndShrink
                        .AutoSize = True
                        .Dock = DockStyle.Top
                    End With
                    commands.Add(cmd)
                End If
            Loop
        Loop

    End Sub

    Public Sub New()

        ' この呼び出しはデザイナーで必要です。
        InitializeComponent()

        ' InitializeComponent() 呼び出しの後で初期化を追加します。

        ' TODO:remove
        Utils.tSetApp(Me)

        ' TODO:レイヤーリスト構築
        Dim cv As New Canvas(Nothing)
        Utils.tSetRootCanvas(cv)
        cv.Layers.Add(New FilterLayer())
        cv.Layers.Add(New RasterLayer(cv))


    End Sub

    Private Sub App_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint

    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        DirectCast(Utils.tGetRootCanvas.Layers(1), RasterLayer).Image.Save("Raster.png", Imaging.ImageFormat.Png)
        Utils.tGetRootCanvas.Image.Save("RootCanvas.png", Imaging.ImageFormat.Png)
    End Sub

    Private Sub TrackBar1_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TrackBar1.Scroll
        With CanvasPanel
            .ViewAngle = TrackBar1.Value
            Using g As Graphics = .CreateGraphics()
                .UpdateSurface_Disp(g, .Bounds)
                .Refresh()
            End Using
        End With
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        TrackBar1.Value = 0

        With CanvasPanel
            .ViewAngle = TrackBar1.Value
            Using g As Graphics = .CreateGraphics()
                .UpdateSurface_Disp(g, .Bounds)
                .Refresh()
            End Using
        End With
    End Sub

    Private Sub TrackBar2_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TrackBar2.Scroll
        With CanvasPanel
            .ViewScale = TrackBar2.Value / 100
            Label3.Text = "x" & .ViewScale.ToString()
            Using g As Graphics = .CreateGraphics()
                .UpdateSurface_Disp(g, .Bounds)
                .Refresh()
            End Using
        End With
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        TrackBar2.Value = 100

        With CanvasPanel
            .ViewScale = TrackBar2.Value / 100
            Label3.Text = "x" & .ViewScale.ToString()
            Using g As Graphics = .CreateGraphics()
                .UpdateSurface_Disp(g, .Bounds)
                .Refresh()
            End Using
        End With
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        With CanvasPanel
            .ScrollOffset = New PointF(0, 0)
            Using g As Graphics = .CreateGraphics()
                .UpdateSurface_Disp(g, .Bounds)
                .Refresh()
            End Using
        End With
    End Sub
End Class
