﻿Imports System.Drawing

Public Class BrokenTile

    Private _apexes As PointF()
    Public Property Apexes() As PointF()
        Get
            Return Me._apexes
        End Get
        Set(ByVal value As PointF())
            Me._apexes = value
        End Set
    End Property

    'Private Shared _size As SizeF = New Size(1600, 1200)
    'Private Shared _size As SizeF = New Size(200, 200)
    Private Shared _size As SizeF = New Size(50, 50)
    'Private Shared _size As SizeF = New Size(20, 20)
    Public Shared Property Size() As SizeF
        Get
            Return BrokenTile._size
        End Get
        Set(ByVal value As SizeF)
            BrokenTile._size = value
        End Set
    End Property

    Private _imageClip As Bitmap
    Public Property ImageClip() As Bitmap
        Get
            Return Me._imageClip
        End Get
        Set(ByVal value As Bitmap)
            Me._imageClip = value
        End Set
    End Property

    Public Shared Function ApexesToRectangleF(ByVal apexes As PointF()) As RectangleF
        Dim LeftTop, RightBottom As PointF

        LeftTop.X = apexes.Min(Function(pt As PointF) pt.X) : LeftTop.Y = apexes.Min(Function(pt As PointF) pt.Y)
        RightBottom.X = apexes.Max(Function(pt As PointF) pt.X) : RightBottom.Y = apexes.Max(Function(pt As PointF) pt.Y)

        'Dim rect As New RectangleF(LeftTop.X, LeftTop.Y, RightBottom.X - LeftTop.X + 1, RightBottom.Y - LeftTop.Y + 1)   'px
        Dim rect As New RectangleF(LeftTop.X, LeftTop.Y, Math.Ceiling(RightBottom.X - LeftTop.X), Math.Ceiling(RightBottom.Y - LeftTop.Y))   'px
        Debug.Assert(rect.Width >= 0 And rect.Height >= 0)
        Return rect

    End Function

    Public Sub New(ByVal location As PointF, Optional ByVal size As SizeF? = Nothing)
        If size Is Nothing Then
            'TODO:設定から得たサイズを使用
        Else
            BrokenTile.Size = size.Value
        End If
        Me._apexes = New PointF() {New PointF(location.X, location.Y), New PointF(location.X + BrokenTile.Size.Width - 1, location.Y), New PointF(location.X + BrokenTile.Size.Width - 1, location.Y + BrokenTile.Size.Height - 1), New PointF(location.X, location.Y + BrokenTile.Size.Height - 1)}
        Dim sz As Size = Drawing.Size.Truncate(BrokenTile.Size)
        Me._imageClip = New Bitmap(sz.Width, sz.Height)
    End Sub

    Protected Overrides Sub Finalize()
        'TODO:Finalizer呼び出しの有効化
        Me._imageClip = Nothing
        MyBase.Finalize()
    End Sub
End Class
