﻿Imports System.Drawing

Public Class RasterLayer : Inherits Layer
    'Public Class RasterLayer : Implements Layer, RasterLayer, LayerListItem

    Private _container As Canvas
    Public Overloads Sub BreakTile(ByVal location As PointF)
        Me._container.BreakTile(location)
    End Sub

    Public Overloads Sub BreakTile(ByVal smashArea As RectangleF)
        Me._container.BreakTile(smashArea)
    End Sub

    Private _image As Image
    ReadOnly Property Image As Image
        Get
            Return Me._image
        End Get
    End Property

    Public Sub Repair(ByRef brokenTile As BrokenTile)
        Using g As Graphics = Utils.GraphicsFromImage(brokenTile.ImageClip)
            'TODO:合成用フィルター（FilterLayerでは使えないフィルター）を使用

            Dim bounds As RectangleF = brokenTile.ImageClip.GetBounds(g.PageUnit)
            g.DrawImage(Me._image, bounds, brokenTile.ApexesToRectangleF(brokenTile.Apexes), g.PageUnit)
        End Using
    End Sub

    Public Function CreateGraphics() As System.Drawing.Graphics
        Return Utils.GraphicsFromImage(Me._image)
    End Function

    Public Sub New(ByVal container As Canvas)
        Dim size As Size = Utils.tGetRootCanvas.Image.Size
        Me._image = New Bitmap(size.Width, size.Height)
        Me._container = container
    End Sub

    Public Overrides Sub Accept(ByVal visitor As Visitor)
        visitor.Visit(Me)
    End Sub

    Protected Overrides Sub Finalize()
        'TODO:Finalizerの有効化
        Me._container = Nothing
        MyBase.Finalize()
    End Sub
End Class
