﻿Public Class CanvasPanel

    Private _viewOrigin As PointF
    Public Property ViewOrigin() As PointF
        Get
            Return Me._viewOrigin
        End Get
        Set(ByVal value As PointF)
            Me._viewOrigin = value
        End Set
    End Property

    Private _scrollOffset As PointF
    Public Property ScrollOffset() As PointF
        Get
            Return Me._scrollOffset
        End Get
        Set(ByVal value As PointF)
            Me._scrollOffset = value
        End Set
    End Property

    Private _angle As Single
    Public Property ViewAngle() As Single
        Get
            Return _angle
        End Get
        Set(ByVal value As Single)
            _angle = value
        End Set
    End Property

    Private _scale As Single
    Public Property ViewScale() As Single
        Get
            Return _scale
        End Get
        Set(ByVal value As Single)
            _scale = value
        End Set
    End Property

    Private _view As Views.RotationScaleScroll
    Public Property View() As Views.RotationScaleScroll
        Get
            Return _view
        End Get
        Set(ByVal value As Views.RotationScaleScroll)
            _view = value
        End Set
    End Property

    Shadows Function CreateGraphics()
        Return Utils.GraphicsFromImage(Me._pictureBox.Image)
    End Function

    Sub CanvasPanel_StylusDown()
    End Sub

    Sub CanvasPanel_StylusUp()
        With Nothing
            Dim cmd As Command = App.ToolPanel.NewSelectedCommand
            cmd.AppEvent = "EndStroke"
            Dim cmd2 As DrawFreehandLine = DirectCast(cmd, DrawFreehandLine)
            cmd2.StrokePoints = New Queue(Of StrokePoint)

            cmd2.Layer = Utils.tGetRootCanvas().Layers.Item(1) '1:rasterlayer

            Dim cv As Canvas = Utils.tGetRootCanvas()
            cv.Accept(DirectCast(cmd2, Visitor))
        End With

        'With Nothing
        '    ' 画面全体更新
        '    'TODO:別スレッドで
        '    Utils.tGetRootCanvas().BreakAllTiles()

        '    'BrokenTilesは無くなる
        '    Dim cmd As New UpdateCanvas()
        '    cmd.AppEvent = ""
        '    Utils.tGetRootCanvas().Accept(DirectCast(cmd, Visitor))

        '    'Utils.tGetApp().CanvasPanel._pictureBox.Refresh()
        '    Utils.tGetApp().CanvasPanel._pictureBox.Invalidate(False)
        'End With

        Using g As Graphics = Me.CreateGraphics()
            Me.Invalidate(True)
            UpdateSurface_Disp(g, Me.Bounds)
        End Using
    End Sub

    Sub CanvasPanel_Packets(ByVal strokePoints As Generic.Queue(Of StrokePoint))
        'Debug.Print(Now & " CanvasPanel_Packets")

        If Me._scrollDeltaOrigin = PointF.Empty Then
            With Nothing
                Dim cmd As Command = App.ToolPanel.NewSelectedCommand
                cmd.AppEvent = "InStroke"
                Dim cmd2 As DrawFreehandLine = DirectCast(cmd, DrawFreehandLine)
                Me._view.FilterInvert(strokePoints)
                cmd2.StrokePoints = strokePoints

                cmd2.Layer = Utils.tGetRootCanvas().Layers.Item(1) '1:rasterlayer
                Dim cv As Canvas = Utils.tGetRootCanvas()
                Debug.Assert(Not IsNothing(cmd2.GetType().GetInterface("Visitor")))

                cv.Accept(DirectCast(cmd2, Visitor))
                'cv.Exec(cmd2)
            End With


            With Nothing
                'Utils.tGetRootCanvas().BreakAllTiles()
                Dim tiles As List(Of BrokenTile) = Utils.tGetRootCanvas.GetBrokenTiles()
                If tiles.Count >= 1 Then
                    ' 画面更新
                    'TODO:別スレッドで
                    Dim cmd As New UpdateCanvas()
                    cmd.AppEvent = ""
                    Utils.tGetRootCanvas().Accept(DirectCast(cmd, Visitor))

                    Debug.Assert(tiles.Count >= 1)
                    Dim apexes As PointF() = tiles.Item(0).Apexes
                    'Debug.Print(apexes(0).ToString() & ", " & apexes(1).ToString() & ", " & apexes(2).ToString() & ", " & apexes(3).ToString())
                    Me._view.Filter(apexes)
                    Dim rect As RectangleF = BrokenTile.ApexesToRectangleF(apexes)
                    tiles.RemoveAt(0)
                    For Each tile In tiles
                        apexes = tile.Apexes
                        Me._view.Filter(apexes)
                        rect = RectangleF.Union(rect, BrokenTile.ApexesToRectangleF(apexes))
                    Next

                    Using g As Graphics = Me.CreateGraphics()
                        Me.Invalidate(Rectangle.Truncate(rect), True)
                        UpdateSurface_Disp(g, rect)

                        'TODO:remove
                        g.DrawRectangle(New Pen(Color.Silver, 2), Rectangle.Truncate(rect))
                    End Using
                End If
            End With
        Else
            ' スクロール
            'Me._pictureBox.Invalidate(False)
        End If


    End Sub

    'Public Sub UpdateSurface(ByVal g As Graphics, ByVal dispRect As RectangleF)
    '    'Debug.Print(Now & " UpdateSurface")
    '    'Dim surfaceLeftTop As New PointF(0, 0)
    '    'Dim documentLeftTop As New PointF(0, 0)
    '    'Dim rectSize As New SizeF(Utils.tGetRootCanvas().Image.Size)

    '    'TODO:RootCanvasの表示用バージョンが無ければ作る。→DispCanvasの更新処理

    '    Me._view = New Views.RotationScaleScroll()
    '    'FIXME:
    '    Me._view.RotationAngle = Me.ViewAngle
    '    Me._view.Scale = Me.ViewScale
    '    Me._view.ScrollOffset = PointF.Add(Me._scrollOffset, Me._scrollDelta)
    '    Me._view.DispRect = dispRect
    '    Me._view.DocRect = RectangleF.Empty
    '    'Me._view.DispRect = RectangleF.Empty
    '    'Me._view.DocRect = docRect
    '    Me._view.Origin = Me._viewOrigin
    '    Me._view.Render(g, Utils.tGetRootCanvas().Image)

    'End Sub

    Public Sub UpdateSurface_Disp(ByVal g As Graphics, ByVal dispRect As RectangleF)
        'Debug.Print(Now & " UpdateSurface_Disp")

        Dim plus As SizeF = New SizeF(dispRect.X Mod BrokenTile.Size.Width, dispRect.Y Mod BrokenTile.Size.Height)
        Dim rect As RectangleF = New RectangleF(dispRect.X - plus.Width, dispRect.Y - plus.Height, dispRect.Width + plus.Width, dispRect.Height + plus.Height)
        'rect = Rectangle.Truncate(rect)

        Dim img As Bitmap = Utils.tGetRootCanvas().Image
        'Dim surfaceLeftTop As New PointF(0, 0)
        'Dim documentLeftTop As New PointF(0, 0)
        'Dim rectSize As New SizeF(Utils.tGetRootCanvas().Image.Size)

        'FIXME:生成し直す必要は無い
        Me._view = New Views.RotationScaleScroll()
        Me._view.RotationAngle = Me.ViewAngle
        Me._view.Scale = Me.ViewScale
        Me._view.ScrollOffset = PointF.Add(Me._scrollOffset, Me._scrollDelta)
        Me._view.DispRect = rect
        Me._view.DocRect = RectangleF.Empty
        'FIXME:UIから得た座標を使用
        Me._view.Origin = New PointF(300, 300)
        'Me._view.Origin = Me._viewOrigin

        Me._view.Render(g, img)

    End Sub

    Private _scrollDeltaOrigin As PointF = PointF.Empty
    Private _scrollDelta As SizeF = SizeF.Empty
    Private Sub _pictureBox_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles _pictureBox.MouseDown
        'Debug.Print(Now & " _pictureBox_MouseDown")
        If e.Button And MouseButtons.Right Then
            Me._scrollDeltaOrigin = e.Location
        End If
    End Sub

    Private Sub _pictureBox_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles _pictureBox.MouseMove
        'Debug.Print(Now & " _pictureBox_MouseMove")

        ' スクロール
        If Me._scrollDeltaOrigin <> PointF.Empty Then
            Me._scrollDelta = SizeF.Subtract(New SizeF(e.Location), New SizeF(Me._scrollDeltaOrigin))

            'TODO:CanvasPanel_Packetsに移動。ビューの操作もCommandにすべき？レスポンスの速さ次第
            Using g As Graphics = Me.CreateGraphics()
                '.Refresh()
                Me.Invalidate(True)
                UpdateSurface_Disp(g, Me.Bounds)
            End Using
        End If
    End Sub

    Private Sub _pictureBox_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles _pictureBox.MouseUp
        'Debug.Print(Now & " _pictureBox_MouseUp")
        Me._scrollOffset = PointF.Add(Me._scrollOffset, Me._scrollDelta)
        Me._scrollDeltaOrigin = PointF.Empty
        Me._scrollDelta = SizeF.Empty
    End Sub

    Private Sub _pictureBox_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles _pictureBox.Paint
        'Debug.Print(Now & "_pictureBox_Paint")
        ' Refresh()など、Paintイベントを発生させる処理不可
        'If e.ClipRectangle.Width > 0 And e.ClipRectangle.Height > 0 Then
        '    Utils.GraphicsConfig(e.Graphics)
        '    Me.UpdateSurface(e.Graphics, e.ClipRectangle)
        'End If
    End Sub

    Public Sub New()

        ' この呼び出しはデザイナーで必要です。
        InitializeComponent()

        ' InitializeComponent() 呼び出しの後で初期化を追加します。
        Me.ViewOrigin = New PointF(0.0F, 0.0F)
        Me.ViewAngle = 0.0F
        Me.ViewScale = 1.0F
        Me.ScrollOffset = New PointF(0.0F, 0.0F)
    End Sub

    Private Sub CanvasPanel_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim rect As Rectangle = Screen.GetWorkingArea(Me)
        Me._pictureBox.Image = New Bitmap(rect.Width, rect.Height)

        Using g As Graphics = Me.CreateGraphics()
            Me.Invalidate(True)
            UpdateSurface_Disp(g, Me.Bounds)
        End Using
    End Sub

    Private Sub CanvasPanel_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseDown
        Debug.Fail("CanvasPanel_MouseDown")
    End Sub

    Private Sub CanvasPanel_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        Me.ViewOrigin = New PointF(Me.Size.Width / 2, Me.Size.Height / 2)
    End Sub
End Class
