﻿Imports System.Collections.Generic

Namespace Views

    Public Class RotationScaleScroll : Inherits View

        ''' <summary>
        ''' 
        ''' </summary>
        ''' <param name="g"></param>
        ''' <param name="img">※全体</param>
        ''' <remarks></remarks>
        Public Sub Render(ByVal g As Graphics, ByVal img As Bitmap)
            Debug.Assert(img.Size.Width = Utils.tGetRootCanvas().Image.Size.Width And img.Size.Height = Utils.tGetRootCanvas().Image.Size.Height)
            Debug.Assert(Me.Scale > 0)

            Debug.Assert(Me._docRect.X Mod 50 = 0 And Me._docRect.Y Mod 50 = 0)

            Dim ang As Single = Me.RotationAngle    ' 描画時の回転角

            g.Clear(Color.Transparent)

            'Debug.Print("* clipRect0: " & Me._dispRect.ToString())

            'clipRect使用
            ' CanvasPenel:BrokenTileの頂点→拡張・矩形（doc座標）→Filter（disp座標）→Invalidate（disp座標）→Me._dispRect（disp座標）
            ' これをFilterInvertで拡張・doc座標に戻している。
            Debug.Assert(Not Me._docRect.IsEmpty Or Not Me._dispRect.IsEmpty)
            If Me._docRect.IsEmpty Then
                With Nothing
                    Dim apexes As PointF() = New PointF() { _
                        New PointF(Me._dispRect.Location.X, Me._dispRect.Location.Y), _
                        New PointF(Me._dispRect.Location.X + Me._dispRect.Width, Me._dispRect.Location.Y), _
                        New PointF(Me._dispRect.Location.X + Me._dispRect.Width, Me._dispRect.Location.Y + Me._dispRect.Height), _
                        New PointF(Me._dispRect.Location.X, Me._dispRect.Location.Y + Me._dispRect.Height)}
                    'FIXME:縮小表示時の頂点座標。←縮小時はdispRectが大きくなる。docRect（キャンバスサイズ）と比べて小さい方を採用するように。docRect使用時はDisp→Doc変換不要
                    FilterInvert(apexes)
                    'FIXME:BrokenTileクラスを使わない。ApexesToRectangleFを移動。
                    Me._docRect = BrokenTile.ApexesToRectangleF(apexes)
                    'ASSERT:clipRectがBrokenTileの矩形を含んでいること。
                End With
            End If

            Dim clipRect As RectangleF
            clipRect = Me._docRect
            'Debug.Print("* clipRect1: " & clipRect.ToString() & IIf(clipRect.X Mod 1 > 0 OrElse clipRect.Y Mod 1 > 0 OrElse clipRect.Width Mod 1 > 0 OrElse clipRect.Height Mod 1, " *** ***", ""))
            clipRect.Inflate(clipRect.Width * Math.Sqrt(2) / 2, clipRect.Height * Math.Sqrt(2) / 2)
            'Debug.Print("* clipRect2, org: " & clipRect.ToString() & ", " & Me.Origin.ToString())

            'Using img2 As Bitmap = New Bitmap(CInt(Math.Ceiling(clipRect.Width)), CInt(Math.Ceiling(clipRect.Height)))
            'Using g2 As Graphics = Utils.GraphicsFromImage(img2)
            '    g2.DrawImage(img, 0, 0, clipRect, g2.PageUnit)
            'End Using

            Dim org As PointF = Me.Origin
            Dim scale As Single = Me.Scale
            Dim scroll As PointF = Me.ScrollOffset

            '' 変換ルール（逆順に適用される）
            g.TranslateTransform(clipRect.X, clipRect.Y) ' 有効範囲内に描画するための移動

            g.TranslateTransform(scroll.X, scroll.Y)  ' 5. スクロール

            g.TranslateTransform(-(-org.X + clipRect.X), -(-org.Y + clipRect.Y))  ' 4. 中心が本来の位置になるよう移動
            'g.translatetransform(org.x, org.y)  ' 4. 中心が本来の位置になるよう移動

            g.RotateTransform(ang)                  ' 2. (0, 0)を中心に回転
            g.ScaleTransform(scale, scale)        ' 3. 倍率

            'HACK:g.PageUnit(=GraphicsUnit.Display)にしたい
            g.PageUnit = GraphicsUnit.Pixel
            g.DrawImage(img, New RectangleF(-org.X + clipRect.X, -org.Y + clipRect.Y, clipRect.Width, clipRect.Height), clipRect, g.PageUnit)    ' 1. (0, 0)に回転と拡大の中心を合わせるように描画

            'TODO:remove
            g.ResetTransform()
            g.DrawRectangle(Pens.Red, org.X + scroll.X, org.Y + scroll.Y, 3, 3)

            ''---------------------------------------------------------------------
            ''img全体を使用 clipRect不使用
            'With Nothing
            '    Dim org As PointF = Me.Origin
            '    Dim scale As Single = Me.Scale
            '    Dim scroll As PointF = Me.ScrollOffset

            '    ' 変換ルール（逆順に適用される）
            '    g.TranslateTransform(scroll.X, scroll.Y)  ' 5. スクロール
            '    g.TranslateTransform(org.X, org.Y)  ' 4. 中心が本来の位置になるよう移動
            '    g.ScaleTransform(scale, scale)        ' 3. 倍率
            '    g.RotateTransform(ang)                  ' 2. (0, 0)を中心に回転
            '    g.DrawImage(img, -org.X, -org.Y)    ' 1. (0, 0)に回転と拡大の中心を合わせるように描画

            '    'TODO:remove
            '    g.ResetTransform()
            '    g.DrawRectangle(Pens.Red, org.X + scroll.X, org.Y + scroll.Y, 3, 3)
            'End With

            ''---------------------------------------------------------------------
            ''img全体を使用(clipRect使用、img2は作らない)
            '' CanvasPenel:BrokenTileの頂点→拡張・矩形（doc座標）→Filter（disp座標）→Invalidate（disp座標）→Me._dispRect（disp座標）
            '' これをFilterInvertで拡張・doc座標に戻している。
            'Debug.Assert(Not Me._docRect.IsEmpty Or Not Me._dispRect.IsEmpty)
            'If Me._docRect.IsEmpty Then
            '    With Nothing
            '        Dim apexes As PointF() = New PointF() { _
            '            New PointF(Me._dispRect.Location.X, Me._dispRect.Location.Y), _
            '            New PointF(Me._dispRect.Location.X + Me._dispRect.Width, Me._dispRect.Location.Y), _
            '            New PointF(Me._dispRect.Location.X + Me._dispRect.Width, Me._dispRect.Location.Y + Me._dispRect.Height), _
            '            New PointF(Me._dispRect.Location.X, Me._dispRect.Location.Y + Me._dispRect.Height)}
            '        'FIXME:縮小表示時の頂点座標。←縮小時はdispRectが大きくなる。docRect（キャンバスサイズ）と比べて小さい方を採用するように。
            '        FilterInvert(apexes)
            '        'FIXME:BrokenTileを使わない
            '        Me._docRect = BrokenTile.ApexesToRectangleF(apexes)
            '        'ASSERT:clipRectがBrokenTileの矩形を含んでいること。
            '    End With
            'End If

            'Dim clipRect As RectangleF
            'clipRect = Me._docRect
            'clipRect.Inflate(clipRect.Width * Math.Sqrt(2) / 2, clipRect.Height * Math.Sqrt(2) / 2)
            'Debug.Print("clipRect: " & clipRect.ToString())

            'With Nothing
            '    Dim org As PointF = Me.Origin
            '    Dim scale As Single = Me.Scale
            '    Dim scroll As PointF = Me.ScrollOffset

            '    ' 変換ルール（逆順に適用される）
            '    g.TranslateTransform(scroll.X, scroll.Y)  ' 5. スクロール
            '    g.TranslateTransform(org.X, org.Y)  ' 4. 中心が本来の位置になるよう移動
            '    g.ScaleTransform(scale, scale)        ' 3. 倍率
            '    g.RotateTransform(ang)                  ' 2. (0, 0)を中心に回転
            '    g.DrawImage(img, -org.X, -org.Y)    ' 1. (0, 0)に回転と拡大の中心を合わせるように描画

            '    'TODO:remove
            '    g.ResetTransform()
            '    g.DrawRectangle(Pens.Red, org.X + scroll.X, org.Y + scroll.Y, 3, 3)
            'End With

        End Sub

        Public Sub New()

            'TODO:UIから得た回転の中心座標を使用
            Me.DispRect = RectangleF.Empty
            Me.DocRect = RectangleF.Empty
            Me.Origin = PointF.Empty
            Me.Scale = 10.0F
            Me.RotationAngle = 0.0F
        End Sub

        Private _docRect As RectangleF
        Public Property DocRect() As RectangleF
            Get
                Return Me._docRect
            End Get
            Set(ByVal value As RectangleF)
                Me._docRect = value
            End Set
        End Property

        Private _dispRect As RectangleF
        Public Property DispRect() As RectangleF
            Get
                Return Me._dispRect
            End Get
            Set(ByVal value As RectangleF)
                Me._dispRect = value
            End Set
        End Property

        Private _scrollOffset As PointF
        Public Property ScrollOffset() As PointF
            Get
                Return Me._scrollOffset
            End Get
            Set(ByVal value As PointF)
                Me._scrollOffset = value
            End Set
        End Property

        ''' <summary>
        ''' 回転の中心
        ''' </summary>
        ''' <remarks></remarks>
        Private _origin As PointF
        Public Property Origin() As PointF
            Get
                Return Me._origin
            End Get
            Set(ByVal value As PointF)
                Me._origin = value
            End Set
        End Property


        Private _scale As Single
        Public Property Scale() As Single
            Get
                Return Me._scale
            End Get
            Set(ByVal value As Single)
                Me._scale = value
            End Set
        End Property

        Private _rotationAngle As Single
        Public Property RotationAngle As Single
            Get
                Return Me._rotationAngle
            End Get
            Set(ByVal value As Single)
                Me._rotationAngle = value
            End Set
        End Property

        ' disp -> doc
        Public Overloads Function FilterInvert(ByVal pt As PointF) As PointF

            Dim ang As Single = -Me.RotationAngle   ' 描画時の回転角
            Dim scale As Single = 1 / Me.Scale
            Dim scroll As PointF = New PointF(-Me.ScrollOffset.X, -Me.ScrollOffset.Y)

            pt = ScrollPoint(pt, scroll)
            pt = ScalePoint(pt, scale, Me.Origin)
            pt = RotatePoint(pt, ang, Me.Origin)

            Return pt

        End Function











        ' doc -> disp
        Public Overloads Function Filter(ByVal pt As PointF) As PointF

            Dim ang As Single = Me.RotationAngle   ' 描画時の回転角
            Dim scale As Single = Me.Scale
            Dim scroll As PointF = New PointF(Me.ScrollOffset.X, Me.ScrollOffset.Y)

            pt = RotatePoint(pt, ang, Me.Origin)
            pt = ScalePoint(pt, scale, Me.Origin)
            pt = ScrollPoint(pt, scroll)

            Return pt

        End Function


        'Private Function RotateRect(ByVal rect As RectangleF, ByVal ang As Single, ByVal org As PointF) As RectangleF
        '    ' Rectangle変換
        '    Dim pts(3) As PointF

        '    With rect
        '        Debug.Assert(.Width >= 1 And .Height >= 1)
        '        pts(0) = New Point(.X, .Y)
        '        pts(1) = New Point(.X + .Width - 1, .Y)    ' px
        '        pts(2) = New Point(.X + .Width - 1, .Y + .Height - 1)
        '        pts(3) = New Point(.X, .Y + .Height - 1)
        '    End With

        '    ' 回転
        '    For i = 0 To pts.Count - 1
        '        pts(i) = RotatePoint(pts(i), ang, org)
        '    Next

        '    Dim LeftTop, RightBottom As PointF
        '    LeftTop.X = pts.Min(Function(pt As PointF) pt.X) : LeftTop.Y = pts.Min(Function(pt As PointF) pt.Y)
        '    RightBottom.X = pts.Max(Function(pt As PointF) pt.X) : RightBottom.Y = pts.Max(Function(pt As PointF) pt.Y)

        '    Return New RectangleF(LeftTop.X, LeftTop.Y, RightBottom.X - LeftTop.X + 1, RightBottom.Y - LeftTop.Y + 1)   'px

        'End Function

        ''' <summary>
        ''' doc -> disp 座標変換
        ''' </summary>
        ''' <param name="pts">ByRef</param>
        ''' <remarks></remarks>
        Public Overloads Sub Filter(ByRef pts As PointF())

            For i As Integer = LBound(pts) To UBound(pts)
                pts(i) = Me.Filter(pts(i))
            Next

        End Sub

        ''' <summary>
        ''' disp -> doc 座標変換
        ''' </summary>
        ''' <param name="pts">ByRef</param>
        ''' <remarks></remarks>
        Public Overloads Sub FilterInvert(ByRef pts As PointF())

            For i As Integer = LBound(pts) To UBound(pts)
                pts(i) = Me.FilterInvert(pts(i))
            Next

        End Sub


        ''' <summary>
        ''' ブラシのための座標変換
        ''' </summary>
        ''' <param name="strokePoints">ByRef</param>
        ''' <remarks></remarks>
        Public Overloads Sub FilterInvert(ByRef strokePoints As Queue(Of StrokePoint))

            For Each sp In strokePoints
                sp.Location = Me.FilterInvert(sp.Location)
            Next

        End Sub

        Private Shared Function ScrollPoint(ByVal pt As PointF, ByVal scroll As PointF) As PointF

            pt.X = pt.X + scroll.X
            pt.Y = pt.Y + scroll.Y

            Return pt

        End Function

        Private Shared Function ScalePoint(ByVal pt As PointF, ByVal scale As Single, ByVal org As PointF) As PointF

            pt.X = (pt.X - org.X) * scale + org.X
            pt.Y = (pt.Y - org.Y) * scale + org.Y

            Return pt

        End Function

        ''' <summary>
        ''' 現在の角度にangを加える; orgを原点として
        ''' </summary>
        ''' <param name="pt"></param>
        ''' <param name="ang">加える角度（度数法での度単位）</param>
        ''' <param name="org"></param>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Private Shared Function RotatePoint(ByVal pt As PointF, ByVal ang As Single, ByVal org As PointF) As PointF
            'FIXME:計算方法
            Dim rad0 As Double = Math.Atan2(pt.Y - org.Y, pt.X - org.X)
            Dim rad As Double = rad0 + (ang * Math.PI / 180)
            Dim r As Double = Math.Sqrt((pt.X - org.X) ^ 2 + (pt.Y - org.Y) ^ 2) ' 「回転の中心と点を結ぶ線分」の長さ

            pt.X = r * Math.Cos(rad) + org.X
            pt.Y = r * Math.Sin(rad) + org.Y

            Return pt

        End Function

    End Class

End Namespace
